.nolist
include \masm32\include\masm32rt.inc

ShowWinErr	PROTO:DWORD

COMMENT @ ticks & mem usage
		Ticks	Mem	Handles GDI
Heap		12000		87		12		4
SysAll	10000		87		14		4
@

Loops	EQU	8000
Strings	EQU	5000

; 8000*5000*66000=2.64E+012

.data?
UseHeap	dd ?	; 1000*2000*66k: 79.97/163 secs Heap, 49 SysAlloc
Ticks	dd ?
ProcHeap	dd ?
ShowErrBuf	dd 100 dup(?)	; 200 chars for Windows errors
StringTable	dd Strings dup (?)	; pointers to string variables

.data
ShowErr	db "Windows error:", 13, 10, 0

s10	db "1234567890", 0			; ten bytes
s2k	db 200 dup ("x234567890"), 0		; 2000
s64k	db 6400 dup ("A234567890"), 0	; 64000

.code

start:	pushad
	invoke GetProcessHeap		; needed for HeapAlloc
	mov ProcHeap, eax
	.REPEAT
	invoke GetTickCount
	mov Ticks, eax
	xor esi, esi			; outer loop counter
	.While esi<Loops
		xor ebx, ebx	; inner loop counter
		.While ebx<Strings
			lea edi, [StringTable+4*ebx]
			mov eax, [edi]
			.if eax
				.if UseHeap
					invoke HeapFree, ProcHeap, 0, eax
				.else
					invoke SysFreeString, eax
				.endif
			.endif
			mov edx, offset s10	; default: a short string
			mov eax, ebx
			add eax, esi	; pseudo-random generator
			bt eax, 0
			.if CARRY?		; odd
				mov edx, offset s2k
			.else
				bt eax, 1
				.if CARRY?
					mov edx, offset s64k
				.endif
			.endif
			.if UseHeap
				push edx
				mov ecx, len(edx)
				inc ecx
				push ecx
				invoke HeapAlloc, ProcHeap,
				HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY, ecx
				pop ecx
				pop edx
				.if eax
					mov [edi], eax		; pointer into stringtable
					invoke MemCopy, edx, [edi], ecx
				.else
					invoke ShowWinErr, 1	; show formatted error
					mov esi, 999999		; get out of the outer loop, too
					.break
				.endif
			.else
				invoke SysAllocStringByteLen, edx, len(edx)
				.if eax
					mov [edi], eax
				.else
					invoke ShowWinErr, 1	; show formatted error
					mov esi, 999999		; get out of the outer loop, too
					.break
				.endif
			.endif
			inc ebx		; inner loop counter
		.Endw
		inc esi			; outer loop counter
		; give us some feedback on where you are...
		print chr$(13, 10, "Loop ")
		print str$(esi)
		print chr$(13, 10, "Length of first string is ")
		lea edi, [StringTable]
		.if UseHeap
			mov eax, len([edi])
			; inc eax
			; invoke StdOut, [edi]	; the string itself
		.else
			invoke SysStringByteLen, [edi]
		.endif
		print str$(eax)
		; invoke StdOut, [edi]	; the string itself
	.Endw
	.While ebx			; free the strings allocated in the last inner loop
		dec ebx
		lea edi, [StringTable+4*ebx]
		mov eax, [edi]
		.if eax
			.if UseHeap
				invoke HeapFree, ProcHeap, 0, eax
			.else
				invoke SysFreeString, eax
			.endif
		.endif
	.Endw
	print chr$(13, 10, "Ticks, UseHeap=")
	print str$(UseHeap)
	print chr$(" : ")
	invoke GetTickCount		; get the timing
	sub eax, Ticks
	push eax
	print str$(eax)
	pop eax
	invoke MessageBox, 0, str$(eax), chr$("Ticks:"), MB_OKCANCEL
	inc UseHeap
	.UNTIL UseHeap==2 || eax==IDCANCEL
	popad
	invoke ExitProcess, 0

ShowWinErr proc ShowFormatted:DWORD
 pushad
 invoke GetLastError
 .if ShowFormatted
	invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,
	0,	; GetItFromSystem
	eax,	; ErrNum
	0,	; Default language
	addr ShowErrBuf,			; where to send the string from system
	400, 0          				; size 400, no arguments
	.if ShowFormatted!=1
		invoke lstrcat, addr ShowErrBuf, ShowFormatted
	.endif
	invoke MessageBox, 0, addr ShowErrBuf, addr ShowErr, MB_OK
 .else
	invoke MessageBox, 0, str$(eax), addr ShowErr, MB_OK
 .endif
 popad
ret
ShowWinErr endp

end start

; OPT_Icon	Eye
; OPT_SUSY	CONSOLE
; OPT_Out	oms.exe
; OPT_WAIT	1
; OPT_RUN	oms.exe

http://www.masm32.com/board/index.php?topic=1915.0

These are the two macros in MASM32 but it has the correct API calls.

Code:
      alloc$ MACRO ln
        invoke SysAllocStringByteLen,0,ln
        mov BYTE PTR [eax], 0
        EXITM <eax>
      ENDM

      free$ MACRO strhandle
        invoke SysFreeString,strhandle
      ENDM
